import React from 'react';
import { Flexbox, Link, Typography } from '../../../index';
import List from '../../../Atoms/List';
import PageItems from '../PageItems';
import ChevronIcon from './components/ChevronIcon';
import { StyledFlexbox, TruncatedPageNumbers } from './components/RegularComponents';
var PageNumberLinkItem = function PageNumberLinkItem(_ref) {
  var _ref$isCurrentPage = _ref.isCurrentPage,
    isCurrentPage = _ref$isCurrentPage === void 0 ? false : _ref$isCurrentPage,
    children = _ref.children,
    onClick = _ref.onClick,
    label = _ref.label,
    href = _ref.href;
  return React.createElement(Flexbox, {
    item: true,
    as: "li"
  }, isCurrentPage ? React.createElement(Typography, {
    type: "secondary",
    color: function color(t) {
      return t.color.cta;
    },
    weight: "bold"
  }, children) : React.createElement(Link, {
    onClick: onClick,
    "aria-label": "".concat(label, " ").concat(children),
    to: href
  }, React.createElement(Typography, {
    type: "secondary",
    color: function color(t) {
      return t.color.text;
    },
    weight: "bold"
  }, children)));
};
var ChevronLink = function ChevronLink(_ref2) {
  var _ref2$direction = _ref2.direction,
    direction = _ref2$direction === void 0 ? 'left' : _ref2$direction,
    onClick = _ref2.onClick,
    label = _ref2.label,
    href = _ref2.href;
  return React.createElement(Link, {
    onClick: onClick,
    "aria-label": label,
    to: href,
    color: "black"
  }, React.createElement(ChevronIcon, {
    direction: direction,
    size: 8
  }));
};
var RegularLinks = function RegularLinks(_ref3) {
  var currentPage = _ref3.currentPage,
    numberOfPages = _ref3.numberOfPages,
    _ref3$onClickPageItem = _ref3.onClickPageItem,
    onClickPageItem = _ref3$onClickPageItem === void 0 ? function () {} : _ref3$onClickPageItem,
    onClickPrevious = _ref3.onClickPrevious,
    onClickNext = _ref3.onClickNext,
    previousPageLabel = _ref3.previousPageLabel,
    nextPageLabel = _ref3.nextPageLabel,
    currentPageLabel = _ref3.currentPageLabel,
    pageItemLabel = _ref3.pageItemLabel,
    getPageHref = _ref3.getPageHref;
  if (numberOfPages <= 1) {
    return null;
  }
  return React.createElement(StyledFlexbox, {
    container: true,
    $numberOfPages: numberOfPages,
    alignItems: "center"
  }, currentPage !== 1 && React.createElement(ChevronLink, {
    direction: "left",
    onClick: onClickPrevious,
    label: previousPageLabel,
    href: getPageHref(currentPage - 1)
  }), React.createElement(Flexbox, {
    container: true,
    item: true,
    flex: "1",
    justifyContent: "center",
    gap: 2,
    as: List
  }, React.createElement(PageItems, {
    currentPage: currentPage,
    numberOfPages: numberOfPages,
    onClickPageItem: onClickPageItem,
    PageItem: PageNumberLinkItem,
    TruncatedPageNumbers: TruncatedPageNumbers,
    currentPageLabel: currentPageLabel,
    pageItemLabel: pageItemLabel,
    getPageHref: getPageHref
  })), currentPage !== numberOfPages && React.createElement(ChevronLink, {
    direction: "right",
    onClick: onClickNext,
    label: nextPageLabel,
    href: getPageHref(currentPage + 1)
  }));
};
export default React.memo(RegularLinks);